note
	description: "[
		Test examples with arrays and regular expressions.
		First test fails as Result is False by default.
		Write your own tests.
		Included libraries:
			base and extension
			Espec unit testing
			Mathmodels
			Gobo structures
			Gobo regular expressions
		]"
	author: "JSO"
	date: "$Date$"
	revision: "$Revision 19.05$"

class
	TEST_EXAMPLE

inherit

	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- initialize tests
		do
			add_boolean_case (agent t0)
			add_boolean_case (agent t3)
		end

feature -- tests

	t0: BOOLEAN
		local
			t1: TUPLE[STRING, INTEGER]
			t2: TUPLE[name: STRING; id: INTEGER]
		do
			comment ("t0: basic tuples")

			t1 := ["alan", 123]
			Result := t1.item (1) ~ "alan" and t1.item (2) = 123 and
							t1[1] ~ "alan" and t1[2] = 123
			check Result end

			create t2
			t2[1] := "mark"
			t2[2] := 246
			Result := t2.item (1) ~ "mark" and t2.item (2) = 246 and
							t2[1] ~ "mark" and t2[2] = 246 and
								t2.name ~ "mark" and t2.id = 246
			check Result end
		end

	t3: BOOLEAN
		local
			ta: ARRAY[TUPLE[name: STRING; id: INTEGER]]
			na: ARRAY[STRING]
		do
			comment ("t1: test array of tuples")

			ta := <<["alan", 123], ["mark", 246], ["tom", 369]>>

			Result :=
				ta[1].name ~ "alan" and ta[3].id = 369
			check Result end

			create na.make_empty
			across
				ta is t -- since ta is an array of tuples, t is of type of its members
			loop
				na.force (t.name, na.count + 1)
			end

			Result := na.count = 3 and na[1] ~ "alan" and na[2] ~ "mark" and na[3] ~ "tom"

		end

end
